(****************** Matematica - corso di LPL: Laboratorio 2020 *****************)
(* ******************************************************************************)
(* Definizione del Linguaggio Small2020: Nucleo di C modificato ed esteso       *)
(* Realizzazione di un Esecutore di Small2020 utilizzando OCaml                 *)
(*                + Laboratorio del 03/04/20  			                        *)
(*                + Da copiare, in SmallC0, prima di modificare   			    *)
(********************************************************************************)

(* ============================================================================ *)
(* The Token, i.e. Lexical Categories *)

type ide = string;;
type num = int;;
type bool = True | False;;


(* ============================================================================ *)
(* The Syntactic Categories *)
(* Vedi Laboratorio2 (slides), laboratorio1: Ocaml del 27/03/20 *)

type tye = 
	Int
	| Bool
	| Void
	| Arr of tye * num
	| Mut of tye
	| Abs of tye * tyeSeq
	and

tyeSeq = tye list
	and	
	
dcl = 
	Const of tye * ide * num
	| Var of tye * ide * exp
	| VarN of tye * ide
	| Array of tye * ide * num
	and 
	
exp = EXP
    and

cmd = CMD
	and 
	
stm = Stm
	;;			

type prog = Prog of ide * stm;;

(* Operations for the AST presentation in the given Concrete Syntax *)

open Printf;; 

let toStringI (i:ide) = sprintf "%s" i;;

let toStringN (n:num) = sprintf "%d" n;;

let toStringB = function
		| True -> "true"
		| False -> "false"
		;;

let rec indent tab = 
		if tab < 0 then ""
		else if tab = 0 then ""
			 else " " ^ (indent (tab-1))
		;;

let rec toStringTye ... (*  completare *)

and

toStringTseq ...  (*  completare *)

and 

toString dcl ...  (*  completare *)




(* ============================================================================ *)
(* The Semantic Structure: Store e Environment *)	
(* Store: Definition *)
 
(* Store: Operations and Exceptions *)

(* Environment: Definition *)
 
(* Environment: Operations and Exceptions *)


(* ============================================================================ *)
(* The Semantic Function: dclSem, expSem, cmdSem, progSem *)


(* ============================================================================ *)
(* The Semantic Function: dclSem *)


(* ============================================================================ *)
(* The Semantic Function: expSem *)


(* ============================================================================ *)
(* The Semantic Function: cmdSem *)


(* ============================================================================ *)
(* The Semantic Function: progSem *)


(* ============================================================================ *)
(* Tests: Abstract Syntax *)
(* esercizio 1 
soluzione data nelle slides di Laboratorio1
*)

(* esercizio 2 
Per le modifiche apportate, confronta SmallC0 con l'appropriata sezione del codice 
sopra. 
*)


(* Tests: Semantic Structures *)
(* Tests: Semantic Functions *)
(* Tests: Programs and Computations *)
(* Tests: State Dumping *)



